﻿using System;
using System.Text;
using Xpand.XAF.Modules.Reactive.Services;
using Xpand.XAF.Modules.Reactive.Extensions;
using System.Linq;
using System.ComponentModel;
using DevExpress.ExpressApp;
using DevExpress.ExpressApp.DC;
using System.Collections.Generic;
using DevExpress.ExpressApp.Model;
using DevExpress.ExpressApp.Editors;
using DevExpress.ExpressApp.Actions;
using DevExpress.ExpressApp.Updating;
using DevExpress.ExpressApp.Model.Core;
using DevExpress.ExpressApp.Model.DomainLogics;
using DevExpress.ExpressApp.Model.NodeGenerators;
using DevExpress.Persistent.BaseImpl;
using DevExpress.ExpressApp.Xpo;
using Xpand.Persistent.Base.General;
using DevExpress.ExpressApp.ReportsV2;
using Sample.BO;

namespace DXApplication1.Module.Win {
    [ToolboxItemFilter("Xaf.Platform.Win")]
    // For more typical usage scenarios, be sure to check out https://docs.devexpress.com/eXpressAppFramework/DevExpress.ExpressApp.ModuleBase.
    public sealed partial class DXApplication1WindowsFormsModule : ModuleBase {
        //private void Application_CreateCustomModelDifferenceStore(Object sender, CreateCustomModelDifferenceStoreEventArgs e) {
        //    e.Store = new ModelDifferenceDbStore((XafApplication)sender, typeof(ModelDifference), true, "Win");
        //    e.Handled = true;
        //}
        private void Application_CreateCustomUserModelDifferenceStore(Object sender, CreateCustomModelDifferenceStoreEventArgs e) {
            e.Store = new ModelDifferenceDbStore((XafApplication)sender, typeof(ModelDifference), false, "Win");
            e.Handled = true;
        }
        public DXApplication1WindowsFormsModule() {
            InitializeComponent();
        }
        public override IEnumerable<ModuleUpdater> GetModuleUpdaters(IObjectSpace objectSpace, Version versionFromDB)
        {
            ModuleUpdater updater = new DatabaseUpdate.Updater(objectSpace, versionFromDB);
            PredefinedReportsUpdater predefinedReportsUpdater =
                 new PredefinedReportsUpdater(Application, objectSpace, versionFromDB);
            predefinedReportsUpdater.AddPredefinedReport<RoomReport>("RoomRep", typeof(Room));
                   return new[] { updater, predefinedReportsUpdater };
        }
        public override void Setup(XafApplication application)
        {
            
            base.Setup(application);
           
        }


        public override void Setup(ApplicationModulesManager moduleManager)
        {
         
            base.Setup(moduleManager);
            //moduleManager.WhenApplication(application => application.WhenListViewCreating(typeof(NonPersistentObject))
            //    .SelectMany(t => ((NonPersistentObjectSpace)t.e.ObjectSpace)
            //        .WhenObjectsGetting()
            //        .Do(_ => _.e.Objects = new BindingList<NonPersistentObject>())))
            //    .Subscribe(this);
        }
    
        public override void CustomizeTypesInfo(ITypesInfo typesInfo)
        {
            base.CustomizeTypesInfo(typesInfo);
            CalculatedPersistentAliasHelper.CustomizeTypesInfo(typesInfo);
        }
       
    }
}
